--
-- 
--

loadfile("luaScripts/screen_reader_common.inc")();
loadfile("luaScripts/ui_utils.inc")();

-- everything other than the prompt_string is optional!
function promptNumberReactory(prompt_string, default_value, scale)
	if not default_value then
		default_value = 0;
	end
	if not scale then
		scale = 1.0;
	end
	local z = 0;
	local is_done = nil;
	local value = nil;
	-- Edit box and text display
	while not is_done do
		-- Put these everywhere to make sure we don't lock up with no easy way to escape!
		checkBreak("disallow pause");
		
		lsPrint(10, 10, z, scale, scale, 0xFFFFFFff, prompt_string);
		
		-- lsEditBox needs a key to uniquely name this edit box
		--   let's just use the prompt!
		-- lsEditBox returns two different things (a state and a value)
		is_done, value = lsEditBox(prompt_string,
			10, 40, z, 100, 30, scale, scale,
			0x000000ff, default_value);
		
		lsPrintWrapped(10, 80, 0, lsScreenX, .75, .75, 0xffffffff, metals, .5);
		
		if lsButtonText(120, 40, z, 100, 0xFFFFFFff, "OK") then
			is_done = 1;
		end

		if is_done and not value then
			error 'Canceled';
		end
		
		if lsButtonText(lsScreenX - 110, lsScreenY - 30, z, 100, 0xFFFFFFff, "End script") then
			error "Clicked End Script button";
		end
	
		if not tonumber(value) then
			is_done = nil;
			lsPrint(10, 80, z, 0.7, 0.7, 0xFF2020ff, "MUST BE A NUMBER");
		end
		
		lsDoFrame();
		lsSleep(30); -- Sleep just so we don't eat up all the CPU for no reason
	end
	
	return tonumber(value);
end

--Offset String
metals = "Brass: 1, Bronze: 2, Metal Blue: 3, Moon Steel: 4, Octec's Alloy: 5, Pewter: 6, Steel: 7, Sun Steel: 8, Thoth's Metal: 9, Water Metal: 10";

function clickAll(image_name, up)
	if nil then
		lsPrintln("Would click '".. image_name .. "'");
		return; -- not clicking buttons for debugging
	end
	-- Find buttons and click them!
	srReadScreen();
	local buttons = findAllImages(image_name);
	
	if #buttons == 0 then
		statusScreen("Could not find specified buttons...");
		return nil;
	else
		statusScreen("Clicking " .. #buttons .. "button(s)...");
		if up then
			for i=#buttons, 1, -1  do
				srClickMouseNoMove(buttons[i][0]+5, buttons[i][1]+3);
				lsSleep(per_click_delay);
			end
		else
			for i=1, #buttons  do
				srClickMouseNoMove(buttons[i][0]+5, buttons[i][1]+3);
				lsSleep(per_click_delay);
			end
		end
		statusScreen("Done clicking (" .. #buttons .. " clicks).");
		lsSleep(50);
		return 1;
	end
end

--[[
OFFSETS = 
brass = 5
moonsteel = 36
pewter = 52
steel = 70
sun steel = 88
thoth's = 101
water metal = 117
--]]

offset = {
5, --brass
21, -- bronze
36, --Metal Blue
52, --Moon steel
70, --Octec's
85, --Pewter
101, --Steel
117, --Sun Steel
133, --Thoth's
150, --water metal
}


loadfile("luaScripts/screen_reader_common.inc")();
loadfile("luaScripts/ui_utils.inc")();

per_click_delay = 50;


up = nil;
right_click = nil

function doit()
	local num_rounds;
	local threshold = promptNumber("What's the least % acceptable?", 87, .75)
--	local type = promptNumberReactory("Enter Offset", 4);
--		lsPrint(10, 60, 0, .5, .5, 0xFFFFFFff, "abcd");
--		lsSleep(200);
	askForWindow("Currently looking for threshold " .. threshold);
	while 1 do
		while clickAll("Ok.png") ~= nil do
			lsSleep(per_click_delay);
		end
		--search for reactories that have finished processing
		--update screen
		clickAll("ThisIs.png");
		--Search for completed reactories
		srReadScreen();
		buttons = findAllImages("StrReact.png");
		local value = 0;
		for i = 1, #buttons do
			for j = 0, 9, 1 do
				--search for the first number
				local buttons2 = srFindImageInRange (j .. "b.png", buttons[i][0] + 61, buttons[i][1], 9, 11, 3000);
				if buttons2 ~= nil then
					value = j;
				end
			end
			--search for the 2nd number
			for j = 0, 9, 1 do
				local buttons2 = srFindImageInRange (j .. "b.png", buttons[i][0] + 69, buttons[i][1], 8, 10, 3000);
				if buttons2 ~= nil then
					value = value * 10 + j;
				end
			end
			--check for 100%
			local buttons2 = srFindImageInRange ("0b.png", buttons[i][0] + 77, buttons[i][1], 8, 10, 3000);
			if buttons2 ~= nil then
				value = value * 10;
			end
			statusScreen("Number found = " .. value);
			--check for whether to reheat or take
			--reheat +53, take +69
			
			if value >= threshold then
				srClickMouseNoMove(buttons[i][0], buttons[i][1] + 69, right_click);
			else
				srClickMouseNoMove(buttons[i][0], buttons[i][1] + 53, right_click);
			end
			lsSleep(per_click_delay);
		end
		--do a search for reactories awaiting loading
		clickAll("Blank.png", true);
		lsSleep(per_click_delay);
		--Search for the reactory pin menu, click button
		
		clickAll("4xbatch.png");
		lsSleep(1000);
	end
end
